.386
.model flat, stdcall
ExitProcess proto, ExitCode:dword
    
.data
  numero1 DB "1111111111110100",0
  numero2 DB "0110111110111011",0
  suma    DW 0
  error   DB 0

.code

long_cad proc
  push ebp
  mov  ebp, esp
  push ebx

  ; ebx apunta al primer caracter de la cadena
  mov  ebx, [ebp + 8]
  
  ; Se inicializa ax con el valor 0
  xor  ax, ax
  
sig_car:
  cmp  [ebx], byte ptr 0
  je   fin_cad
  inc  ax
  inc  ebx
  jmp  sig_car
  
fin_cad:
  pop  ebx
  pop  ebp
  ret  4
long_cad endp

convierte proc
  push ebp
  mov  ebp, esp
  
  push ebx
  push ecx
  
  ; ebx apunta al primer caracter de la cadena
  mov  ebx, [ebp+8]
  
  ; Se calcula la longitud de la cadena
  push ebx
  call long_cad
  
  ; Comprobar que la longitud es de 16 bits
  cmp  ax, 16
  jne  dev_error    ; devolver -1 en DX
  
  xor  ax, ax       ; pone AX a cero
  mov  dx, 8000h    ; pone el bit 15 a 1
  ; Repetir 16 veces, una para cada bit
  mov  ecx, 16
bucle:
  cmp  [ebx], byte ptr '1'
  jne  zero
  or   ax, dx       ; Si el caracter es '1', pone a 1
                    ; el bit de AX indicado en DX
  jmp  prepara_sig
zero:
  cmp  [ebx], byte ptr '0'
  jne  dev_error
prepara_sig:
  shr  dx, 1        ; Desplaza el 1 un bit a la derecha
  inc  ebx
  loop bucle
  jmp dev_valor
dev_error:
  mov  dx, -1
dev_valor:
  pop  ecx
  pop  ebx
  pop  ebp
  ret  4
convierte endp

inicio: 
  ; Convertir numero1
  push offset numero1
  call convierte      
  
  cmp dx, -1
  je escr_error
  mov [suma], ax

  ; Convertir numero2
  push offset numero2
  call convierte
  
  cmp dx, -1
  je escr_error
  add [suma], ax
  jmp fin      
  
  ; Escribir error
escr_error:        
  mov [error], -1

  ; Retorno al S.O.      
fin:  
  push 0
  call ExitProcess
end inicio