.386
.model flat, stdcall
ExitProcess proto, ExitCode:dword
MessageBoxA proto ,:dword, :dword, :dword, :dword

.data
  Apellidos DB "Von Neumann", 0
  Nombre    DB "Juan", 0
  Completo  DB 100 DUP(0)
  Titulo    DB "Resultado", 0

.code

Mayuscula proc
  mov eax, [esp + 4] ; fpo: frame pointer omission
  cmp al, 'a'
  jb NoEsCaracterMinus
  
  cmp al, 'z'
  ja NoEsCaracterMinus
  
  and al, 0DFh

NoEsCaracterMinus:
  ret 4
Mayuscula endp

Concatenar proc
  push ebp
  mov ebp, esp
  
  push esi
  push edi
  push eax
  
  ; Cargar en esi la direccion de la primera cadena
  mov esi, [ebp+16]
  
  ; Cargar en edi la direccion de destino
  mov edi, [ebp+8]
 
  ; Copiar la primera cadena, hasta encontrar el 0
lazo1:
  mov al, [esi]
  cmp al, 0
  je fin_lazo1
  
  ; Llamamos a Mayuscula pasando eax como parametro
  push eax
  call Mayuscula
  
  ; en al obtenemos la letra ya pasada a mayusculas
  mov [edi], al
  inc esi
  inc edi
  jmp lazo1
  
fin_lazo1:
  ; Aadimos al destino un espacio en blanco
  mov byte ptr [edi], ' '
  inc edi
 
  ; Cargar en ESI la direccion de la segunda cadena
  mov  esi, [ebp+12]
 
  ; Copiar la segunda cadena, hasta encontrar el 0
  ; analogo a lo comentado en lazo1
lazo2:
  mov al, [esi]
  cmp al, 0
  je fin_lazo2
    
  push eax
  call Mayuscula
      
  mov  [edi], al
  inc  esi
  inc  edi
  jmp  lazo2
  
fin_lazo2:
  ; Aadimos el byte 0 como terminador a destino
  mov  byte ptr [edi], 0
  
  ; y retornamos
  pop  eax
  pop  edi
  pop  esi
  
  pop  ebp
  ret  12
Concatenar endp

Imprimir proc
  push ebp
  mov ebp, esp
  push edx

  ; Obtener en edx la direccion de la cadena a imprimir
  mov  edx, [ebp+8]
  

  ; Apilar los cuatro parametros que requiere MessageBoxA
  ; Primero, tipo de ventana
  ; Segundo, direccion del titulo
  ; Tercero, direccion de la cadena a mostrar
  ; Finalmente, propietario = 0
  push 40h
  push OFFSET Titulo
  push edx
  push 0
  call MessageBoxA

  ; Una vez impreso el mensaje, retornamos
  pop edx
  pop ebp
  ret
Imprimir endp  

inicio:        
  ; Preparamos los parmetros para llamar a Concatenar
  ; 1er parmetro:           Nombre
  ; 2o parmetro:            Apellidos
  ; 3er parmetro (destino): Completo
  push offset Nombre
  push offset Apellidos
  push offset Completo
  call Concatenar

  ; Ahora preparamos los parmetros para imprimir Completo
  mov eax, offset Completo
  push eax
  call Imprimir
  add esp, 4

  ; Terminamos solicitando a Windows que finalice este programa
  push 0
  call ExitProcess
END inicio     
