.386
.model flat, stdcall
ExitProcess proto, ExitCode:dword

.data
  n_elem dd 4
  Dividendos dd 12, 25, 14, 84
  ValorK dd 5
  Cocientes dd 4 dup(0)
  Restos db 4 dup(0)


.code

Div_K proc
  push ebp
  mov ebp, esp
  
  push ecx
  push esi
  push edi
  push ebx
  push eax
  push edx
  
  ;Cargamos en ECX el nmero de elementos a procesar
  mov ecx, [ebp + 24]
  
  ;Leemos de la pila la direccin de la lista de dividendos
  mov ebx, [ebp + 20]
  
  ;Leemos de la pila el valor del divisor constante 
  mov eax, [ebp + 16]
  
  ;Leemos de la pila la direccin de la lista de cocientes
  mov esi, [ebp + 12]
  
  ;Leemos de la pila la direccin de la lista de restos
  mov edi, [ebp + 8]

otro:
  ;Pasamos los parmetros a dividir y llamamos a la funcin
  ;Apilamos el dividendo
  push dword ptr [ebx]
  
  ;Apilamos el divisor
  push eax
  
  ;Apilamos la direccin donde se deja el cociente
  push esi
  
  ;Apilamos la direccin donde se deja el resto
  push edi
  
  ;Llamamos al procedimiento
  call dividir
  
  ;Pasamos al siguiente elemento de las listas
  add ebx, 4
  add esi, 4
  add edi, 4
  loop otro       

  ;Desapilamos todos los registros guardados y regresamos
  pop edx
  pop eax
  pop ebx
  pop edi
  pop esi
  pop ecx
  
  pop ebp
  ret
Div_K endp

dividir proc
  push ebp
  mov ebp, esp
  
  push eax
  push ecx
  push edx
  push esi
  
  ;Cargamos en EAX el valor del dividendo \llabel{l:dividir:dividendo}
  mov eax, [ebp + 20]
  
  ;Cargamos en ECX el valor del divisor \llabel{l:dividir:divisor}
  mov ecx, [ebp + 16]
  
  ;Inicializamos el cociente a cero
  mov edx, 0
bucle:
  ;Operamos solo si el dividendo >= divisor
  cmp eax, ecx
  jb no_entra
  
  ;Si es mayor le restamos el divisor
  sub eax, ecx
  
  ;Incrementamos el cociente
  inc edx
  jmp short bucle

no_entra:
  ;Si es menor acabamos de dividir
  ;Leemos de la pila la direccin donde dejar el cociente  \llabel{l:divxk:DIVIDIR:25}
  mov esi, [ebp + 12]

  ;Guardamos el cociente
  mov [esi], edx

  ;Leemos de la pila la direccin donde dejar el resto
  mov esi, [ebp+8]

  ;Guardamos el resto
  mov [esi], eax

  ;Desapilamos los registros y retornamos
  pop esi
  pop edx
  pop ecx
  pop eax
  
  pop ebp
  ret 16
dividir endp

inicio:
  mov edx, [n_elem]
  push edx
  
  mov eax, offset dividendos
  push eax
  
  mov eax, [ValorK]
  push eax
  
  mov eax, offset cocientes
  push eax
  
  mov eax, offset restos
  push eax
  
  call Div_K
  add esp, 20
  
  push 0
  call ExitProcess
end inicio