.386
.model flat, stdcall
ExitProcess proto, ExitCode: dword

.data
  Meses DB "Ene", "Feb", "Mar", "Abr",
    "May", "Jun", "Jul", "Ago", "Sep", 
    "Oct", "Nov", "Dic"
  FechaOrigen1 DB "02/06/2007"
  FechaOrigen2 DB "31/12/2007"
  FechaDestino1 DB 11 DUP (0)
  FechaDestino2 DB 11 DUP (0)

.code

FormateaFecha proc
  push ebp
  mov ebp, esp
  push eax
  push ebx
  push ecx
  push edx  
  
  mov eax, [ebp+12] ; Dir. cad. origen
  mov ebx, [ebp+8]  ; Dir. cad. resultado
  
  xor ecx, ecx
  
CopiaDia:
  mov dl, [eax+ecx]
  mov [ebx+ecx], dl
  inc ecx
  cmp ecx, 3
  jne CopiaDia
  
  ; Copiar mes transformado en texto
  mov edx, eax
  add edx, ecx
  push edx
  mov edx, ebx
  add edx, ecx
  push edx
  call ObtenerNombreMes
  
  add ecx, 2
  
CopiaAgno:
  mov dl, [eax+ecx]
  mov [ebx+ecx+1], dl ; +1 porque el mes como texto ocupa ms
  inc ecx
  cmp ecx, 10
  jne CopiaAgno
  
  pop edx
  pop ecx
  pop ebx
  pop eax
  pop ebp
  ret 8
FormateaFecha endp

; Recibe un nmero entre 1 y 12 y la direccin de
; la cadena donde debe dejar su nombre de tres letras
ObtenerNombreMes proc
  push ebp
  mov ebp, esp
  push eax
  push ebx
  push ecx
  push edx
  push esi
  
  mov eax, [ebp+8]  ; dir. cad. resultado
  mov ebx, [ebp+12] ; nm. de mes en ASCII
  
  ; Pasar el nmero de mes a nmero (en cl)
  xor ecx, ecx
  mov dl, [ebx]
  cmp dl, '1'
  jne noEsUno
  mov cl, 10
  
noEsUno:
  mov dl, [ebx+1]
  sub dl, '0'
  add cl, dl
  
  ; Pasar el nmero de mes (ordinal) a un ndice (cardinal)
  dec ecx ; El mes 1 tiene ndice 0; el 2, 1; etc.
  
  ; Multiplicar ecx por tres
  mov esi, ecx
  add ecx, esi
  add ecx, esi
  
  xor ebx, ebx ; ebx = ndice del car. a copiar
CopiaCaracterMes:
  mov dl, [Meses + ecx + ebx]
  mov [eax + ebx], dl
  inc ebx
  cmp ebx, 3
  jne CopiaCaracterMes

  pop esi
  pop edx
  pop ecx
  pop ebx
  pop eax
  pop ebp
  ret 8
ObtenerNombreMes endp 

Main:
  push offset FechaOrigen1
  push offset FechaDestino1
  call FormateaFecha

  push offset FechaOrigen2
  push offset FechaDestino2
  call FormateaFecha

  push 0
  call ExitProcess
end Main